#ifndef OBJECT
#define OBJECT 106

#include "def.h"
#include "string.h"

struct Record
{
	BYTE Record;
	struct Record  * Next;
};


class CObjFile
{
  private:
	BOOL HeaderWritten; 	//1 if a record is half written else 0
	BOOL Code;              //1 if a Code record is half written
	WORD Segment, Offset, RelativeOffset ;
	BYTE Chksum;
	WORD Length;
	long LengthLocation;
	FILE *fp;
	struct Record * FixStart, *FixLast;
	BOOL FlushCode();
	BOOL FlushFixup();
	BOOL AddFixupRec(const BYTE * Data);

  public :
	CObjFile( );
	CObjFile( CString &File, CString &Name);
	~CObjFile();
	void Error(char *Message);
	BOOL WriteRecHdr(BYTE);
	BOOL WriteRec(const BYTE * Start, int length);
	BOOL WriteChksum();
	BOOL WriteLNameHdr();
	BOOL WriteLName(CString &LName);
	BOOL WriteLName();
	BOOL WriteIndex(unsigned int idx);
	BOOL WriteFixupIndex(unsigned int idx);
	BOOL AcceptCodeHdr(WORD Seg, WORD Off);
	BOOL WriteCode(BYTE const * Start, int length );
	BOOL WriteCodeData(void * Start, int length );
	BOOL WriteFixupRec(const BYTE * Start, int length);
	WORD GetRelativeOffset();
};

#endif
